<!--
******************************************************************************
* Copyright © 2017-2018 PTA GmbH.
* All rights reserved. This program and the accompanying materials
* are made available under the terms of the Eclipse Public License v1.0
* which accompanies this distribution, and is available at
* 
*     http://www.eclipse.org/legal/epl-v10.html
* 
******************************************************************************
-->

<form #entryForm="ngForm" class="entry-dialog-form">
  <header>
    <h2
      *ngIf="
        !isPresenceReminderDialog &&
        !isInstructionDialog &&
        !isEditDialog &&
        !isReadOnlyDialog
      "
    >
      Betriebstagebucheintrag anlegen
    </h2>
    <h2 *ngIf="isInstructionDialog && !isEditDialog && !isReadOnlyDialog">
      Anweisung anlegen
    </h2>
    <h2 *ngIf="isPresenceReminderDialog && !isEditDialog && !isReadOnlyDialog">
      Türkontaktmeldung anlegen
    </h2>
    <h2
      *ngIf="
        !isPresenceReminderDialog &&
        !isInstructionDialog &&
        isEditDialog &&
        !isReadOnlyDialog
      "
    >
      Betriebstagebucheintrag bearbeiten
    </h2>
    <h2 *ngIf="isInstructionDialog && isEditDialog && !isReadOnlyDialog">
      Anweisung bearbeiten
    </h2>
    <h2 *ngIf="isPresenceReminderDialog && isEditDialog && !isReadOnlyDialog">
      Türkontaktmeldung bearbeiten
    </h2>
    <table *ngIf="isReadOnlyDialog && notificationVersions" id="mainEntryTable">
      <tbody>
        <tr>
          <td class="text-left" colspan="3">
            <label style="font-size: 30px; margin-left: 5px"
              >Meldungshistorie anzeigen</label
            >
          </td>
        </tr>
        <tr>
          <td class="text-left">
            <label style="font-size: 22px; margin-right: 5px; margin-left: 5px"
              >Version</label
            >
          </td>
          <td class="text-right" style="width: 70px">
            <div class="form-group">
              <select
                style="height: 30px !important"
                class="form-control"
                name="notificationSelection"
                (change)="onNotificationVersionChange($event.target.value)"
              >
                <option
                  class="nvo"
                  dir="rtl"
                  *ngFor="let notificationVersion of notificationVersions"
                  [selected]="
                    notificationVersion.version === notification.version
                  "
                >
                  {{ notificationVersion.version }}
                </option>
              </select>
            </div>
          </td>
          <td class="text-left">
            <label style="font-size: 22px; margin-left: 5px"
              >erstellt am
              {{
                notification.modDate || notification.createDate
                  | formattedTimestamp : 'DD.MM.YYYY HH:mm'
              }}</label
            >
          </td>
        </tr>
      </tbody>
    </table>
  </header>
  <fieldset [disabled]="isReadOnlyDialog">
    <div class="panel panel-default entry-dialog">
      <div class="panel-body">
        <table class="table">
          <tbody>
            <tr>
              <td class="text-right">
                <label>Priorität</label>
              </td>
              <td class="text-left" style="width: 17%">
                <div class="form-group">
                  <select
                    class="form-control"
                    [(ngModel)]="notification.fkRefNotificationPriority"
                    (ngModelChange)="
                      notification.fkRefNotificationPriority = $event
                        ? $event
                        : null
                    "
                    name="prioSelection"
                  >
                    <option value=""></option>
                    <option
                      *ngFor="let priority of priorities"
                      value="{{ priority.id }}"
                    >
                      {{ priority.name }}
                    </option>
                  </select>
                </div>
              </td>
              <td></td>
              <td class="text-right">
                <label>Bereich</label>
              </td>
              <td class="text-left" style="width: 17%">
                <div class="form-group">
                  <select
                    class="form-control"
                    [(ngModel)]="notification.fkRefBranch"
                    (ngModelChange)="
                      notification.fkRefBranch = $event ? $event : null
                    "
                    name="branchSelection"
                    [required]="
                      !isReadOnlyDialog &&
                      !isInstructionDialog &&
                      !isPresenceReminderDialog
                    "
                  >
                    <option *ngIf="isInstructionDialog" value=""></option>
                    <option *ngIf="isPresenceReminderDialog" value=""></option>
                    <option
                      *ngFor="let branch of branches"
                      value="{{ branch.id }}"
                    >
                      {{ branch.description }}
                    </option>
                  </select>
                </div>
              </td>
              <td></td>
              <td class="text-right">
                <label>Netzgebiet</label>
              </td>
              <td class="text-left" style="width: 17%">
                <div class="form-group">
                  <select
                    class="form-control"
                    [(ngModel)]="notification.fkRefGridTerritory"
                    (ngModelChange)="
                      notification.fkRefGridTerritory = $event ? $event : null
                    "
                    name="gridTerritorySelection"
                    [required]="
                      !isReadOnlyDialog &&
                      !isInstructionDialog &&
                      !isPresenceReminderDialog
                    "
                  >
                    <option *ngIf="isInstructionDialog" value=""></option>
                    <option *ngIf="isPresenceReminderDialog" value=""></option>
                    <option
                      *ngFor="let gridTerritory of gridTerritories"
                      value="{{ gridTerritory.id }}"
                    >
                      {{ gridTerritory.description }}
                    </option>
                  </select>
                </div>
              </td>
              <td></td>
              <td colspan="1" class="text-right">
                <label>Status</label>
              </td>
              <td class="text-left" style="width: 17%">
                <select
                  class="form-control"
                  name="status"
                  [(ngModel)]="notification.fkRefNotificationStatus"
                  (ngModelChange)="statusChanged($event, notification)"
                  name="statusSelection"
                  [required]="!isReadOnlyDialog"
                >
                  <option
                    *ngFor="let status of statuses"
                    value="{{ status.id }}"
                  >
                    {{ status.name }}
                  </option>
                </select>
              </td>
              <td></td>
            </tr>
          </tbody>
        </table>
        <table class="table">
          <tbody>
            <tr>
              <td colspan="10">
                <textarea
                  class="form-control entry-textarea"
                  placeholder="Meldungstext"
                  [(ngModel)]="notification.notificationText"
                  name="notificationTextArea"
                  maxlength="200"
                  [required]="!isReadOnlyDialog"
                ></textarea>
              </td>
            </tr>
            <tr>
              <td colspan="10">
                <textarea
                  class="form-control entry-textarea"
                  placeholder="Freitext"
                  [(ngModel)]="notification.freeText"
                  name="freeTextArea"
                  maxlength="1000"
                ></textarea>
              </td>
            </tr>
            <tr>
              <td colspan="10">
                <textarea
                  class="form-control entry-textarea"
                  placeholder="weiterer Freitext"
                  [(ngModel)]="notification.freeTextExtended"
                  name="freeTextExtendedTextArea"
                  maxlength="1000"
                ></textarea>
              </td>
            </tr>
            <tr>
              <td>
                <label>Zuständigkeit / weitergeleitet an</label>
              </td>
              <td colspan="2">
                <app-autocomplete
                  [(notification)]="notification"
                ></app-autocomplete>
              </td>
              <td></td>
              <td>
                <label>Erledigt vorauss. bis</label>
              </td>
              <td colspan="2">
                <div class="input-group">
                  <app-date-time-picker
                    [currentDate]="notification.expectedFinishDate"
                    (date)="
                      notification.expectedFinishDate =
                        $event.currentDate.toDate()
                    "
                  ></app-date-time-picker>
                  <app-remove-button
                    [(nullableAttribute)]="notification.expectedFinishDate"
                    class="removeBtn"
                    *ngIf="!isReadOnlyDialog"
                  ></app-remove-button>
                </div>
              </td>
            </tr>
            <tr>
              <td>
                <label>Letzter Bearbeiter</label>
              </td>
              <td colspan="2">
                <input
                  class="form-control entry-input last_change_usr_test"
                  type="text"
                  [(ngModel)]="notification.responsibilityControlPoint"
                  name="responsibilityControlPointInput"
                  [disabled]="true"
                />
              </td>
              <td></td>
              <td>
                <label>Beginnt am</label>
              </td>
              <td colspan="2">
                <div class="input-group">
                  <app-date-time-picker
                    [currentDate]="notification.beginDate"
                    [disabled]="isReadOnlyDialog"
                    [required]="true"
                    (date)="
                      notification.beginDate = $event.currentDate.toDate()
                    "
                  ></app-date-time-picker>
                </div>
              </td>
            </tr>
            <tr>
              <td style="width: 24%">
                <label>Erinnerung</label>
              </td>
              <td colspan="2">
                <div class="input-group">
                  <app-date-time-picker
                    [currentDate]="notification.reminderDate"
                    [disabled]="isReadOnlyDialog"
                    (date)="
                      notification.reminderDate = $event.currentDate.toDate()
                    "
                  ></app-date-time-picker>
                  <app-remove-button
                    [(nullableAttribute)]="notification.reminderDate"
                    class="removeBtn"
                    *ngIf="!isReadOnlyDialog"
                  ></app-remove-button>
                </div>
              </td>
              <td style="width: 2%"></td>
              <td style="width: 20%">
                <label>Erledigt am</label>
              </td>
              <td colspan="2">
                <div class="input-group">
                  <app-date-time-picker
                    [currentDate]="notification.finishedDate"
                    [disabled]="true"
                    (date)="
                      notification.finishedDate = $event.currentDate.toDate()
                    "
                  ></app-date-time-picker>
                </div>
              </td>
            </tr>
            <tr>
              <td>
                <label>Datum/Uhrzeit</label>
              </td>
              <td colspan="2">
                <div class="input-group">
                  <app-date-time-picker
                    [currentDate]="notification.createDate"
                    [disabled]="true"
                    (date)="
                      notification.createDate = $event.currentDate.toDate()
                    "
                  ></app-date-time-picker>
                </div>
              </td>
              <td></td>
              <td>
                <label>Initialer Ersteller</label>
              </td>
              <td colspan="2">
                <input
                  class="form-control entry-input"
                  type="text"
                  [(ngModel)]="notification.createUser"
                  disabled="true"
                  name="creatorInput"
                />
              </td>
            </tr>
          </tbody>
        </table>
      </div>
    </div>
  </fieldset>
  <div>
    <button
      *ngIf="isEditDialog && !isReadOnlyDialog"
      class="btn btn-primary btn-sm btn-success"
      (click)="edit()"
      autofocus
      type="submit"
      [disabled]="!entryForm.form.valid"
    >
      Ändern
    </button>
    <button
      *ngIf="!isEditDialog && !isReadOnlyDialog"
      class="btn btn-primary btn-sm btn-success"
      (click)="add()"
      autofocus
      type="submit"
      [disabled]="!entryForm.form.valid"
    >
      Hinzufügen
    </button>
    <button class="btn btn-primary btn-sm" type="button" (click)="cancel()">
      Abbrechen
    </button>
  </div>
</form>
